##############################################################
## IEEE-754 Calculator Application for SWEN4342.02          ##
##                                                          ##
##                                                          ##
## Author/Tester:                                           ##
##                                                          ##
## Richard Davis                                            ##
##                                                          ##
## Purpose: Collection of functions to run the IEEE-754     ##
##          calculator application                          ##
##                                                          ##
## Contains:                                     | Update:  ##
## Value(class)..................................|  2Nov22  ##
## Add...........................................|  2Nov22  ##
## Subtract......................................|  2Nov22  ##
## Multiply......................................|  2Nov22  ##
## SEM_FloatOperation............................|  6Dec22  ##
## SEM_HexOperation..............................|  6Dec22  ##
## SEM_BinOperation..............................|  6Dec22  ##
## FloatToBinary.................................|  2Nov22  ##
## HexToFloat....................................|  6Dec22  ##
## BinaryToFloat.................................|  2Nov22  ##
## FloatToBinary2................................|  6Dec22  ##
## SEM_FloatToHex................................|  6Dec22  ##
## ValType2......................................|  6Dec22  ##
## UserInputSEM_Float1...........................|  6Dec22  ##
## UserInputSEM_Float2...........................|  6Dec22  ##
## hex_SEM_fix1..................................|  6Dec22  ##
## hex_SEM_fix2..................................|  6Dec22  ##
## UserInputSEM_Hex_Fix1.........................|  6Dec22  ##
## UserInputSEM_Hex_Fix2.........................|  6Dec22  ##
## bin_SEM_fix1..................................|  6Dec22  ##
## bin_SEM_fix2..................................|  6Dec22  ##
## UserInputSEM_Bin_Fix1.........................|  6Dec22  ##
## UserInputSEM_Bin_Fix2.........................|  6Dec22  ##
## Main..........................................|  6Dec22  ##
##                                                          ##
## Date: 6Dec22                                             ##
##############################################################

##Import Internal Python Libraries
import time
import struct
import ctypes
from ctypes import *
import decimal
from decimal import Decimal
import math


##############################################################
## Value(class)                                             ##
##                                                          ##
## Author: Davis, Richard                                   ##
##                                                          ##
## Purpose: Creates a generic class  and establishes get,   ##
##          set, and delete properties                      ##
##                                                          ##
## Usage: def: Add(a,b)                                     ##
##              add = Value()                               ##
##        def: Subtract(a,b)                                ##
##              subtract = Value()                          ##
##        def: Multiply(a,b)                                ##
##              multiply = Value()                          ##
##                                                          ##
## Returns: no return type                                  ##
##                                                          ##
## Functions Called:                                        ##
##  _ini      | SARN_IEEE754_Converter_Calculator_v2.4.1.py ##
##  get_value | SARN_IEEE754_Converter_Calculator_v2.4.1.py ##
##  set_value | SARN_IEEE754_Converter_Calculator_v2.4.1.py ##
##  del_value | SARN_IEEE754_Converter_Calculator_v2.4.1.py ##
##                                                          ##
## Date: 2Nov22                                             ##
##############################################################

#Implementation of Values class getters & setters
class Value:
    def _init_(value_type):
        value_type._value = 0
    def get_value(value_type):
        return value_type._value
    def set_value(value_type, v):
        value_type._value = v
    def del_value(value_type):
        del value_type._value
    value = property(get_value, set_value, del_value)
 
 
############################################################################
## Add                                                                    ##
##                                                                        ##
## Author: Davis, Richard                                                 ##
##                                                                        ##
## Purpose: creates a generic add function                                ##
##                                                                        ##
## Usage: def:    SEM_FloatOperation                                      ##
##                SEM_HexOperation                                        ##
##                SEM_BinOperation                                        ##
##                                                                        ##
## Returns: sum of inputs                                                 ##
##                                                                        ##
## Functions: Value(class) | SARN_IEEE754_Converter_Calculator_v2.4.1.py  ##
##                                                                        ##
## Date: 2Nov22                                                           ##
############################################################################

#Define and calculate Add
def Add(a,b):
    try:
        val1 = a
        val2 = b
        print()

        add = Value()
        add.value = (val1+val2)
        return add.value

    except ValueError:
                print("\nInvalid entry error code 1\n")
        
        
############################################################################
## Subtract                                                               ##          
##                                                                        ##
## Author: Davis, Richard                                                 ##
##                                                                        ##
## Purpose: creates a generic subtract function                           ##
##                                                                        ##
## Usage: def:    SEM_FloatOperation                                      ##
##                SEM_HexOperation                                        ##
##                SEM_BinOperation                                        ##
##                                                                        ##
## Returns: difference of inputs                                          ##
##                                                                        ##
## Functions: Value(class) | SARN_IEEE754_Converter_Calculator_v2.4.1.py  ##
##                                                                        ##
## Date: 2Nov22                                                           ##
############################################################################

#Define and calculate Subtract
def Subtract(a,b):
    try:
        val1 = a
        val2 = b
        print()

        subtract = Value()
        subtract.value = (val1-val2)
        return subtract.value

    except ValueError:
        print("\nInvalid entry error code 2\n")
              
              
############################################################################
## Multiply                                                               ##
##                                                                        ##
## Author: Davis, Richard                                                 ##
##                                                                        ##
## Purpose: creates a generic add function                                ##
##                                                                        ##
## Usage: def:    SEM_FloatOperation                                      ##
##                SEM_HexOperation                                        ##
##                SEM_BinOperation                                        ##
##                                                                        ##
## Returns: product of inputs                                             ##
##                                                                        ##
## Functions: Value(class) | SARN_IEEE754_Converter_Calculator_v2.4.1.py  ##
##                                                                        ##
## Date: 2Nov22                                                           ##
############################################################################

#Define and calculate Multiply
def Multiply(a,b):
    try:
        val1 = a
        val2 = b
        print()
        
        multiply = Value()
        multiply.value = (val1*val2)
        return multiply.value

    except ValueError:
        print("\nInvalid entry error code 3\n")
        
        
############################################################################
## SEM_FloatOperation                                                     ##
##                                                                        ##
## Author: Davis, Richard                                                 ##
##                                                                        ##
## Purpose:  to take and handle input in the form of IEEE-754 floating    ##
##                                                                        ##
## Usage: def: ValType2                                                   ##
##                                                                        ##
## Returns: IEEE Floating point value passed through operation choice     ##
##                                                                        ##
## Functions:                                                             ##
## Add                    | SARN_IEEE754_Converter_Calculator_v2.4.1.py   ##
## Subtract               | SARN_IEEE754_Converter_Calculator_v2.4.1.py   ##
## Multiply               | SARN_IEEE754_Converter_Calculator_v2.4.1.py   ##
## UserInputSEM_Bin_Fix1  | SARN_IEEE754_Converter_Calculator_v2.4.1.py   ##
##                                                                        ##
## Date: 6Dec22                                                           ##
############################################################################

#Define float operational choices
def SEM_FloatOperation():
    
    choices = ['1','2','3','4']
    choice = input("\nSelect from the following choices:\n\n1 for Add\n2 for Subtract\n3 for Multiply\n4 to convert or show output\n\n Your Choice: ")
    print()
    try:
        while choice in choices:
                        
            if(choice == '1'):
                result = Add(UserInputSEM_Float1(),UserInputSEM_Float2())
                return result
                break
                            
            if(choice == '2'):
                result = Subtract(UserInputSEM_Float1(),UserInputSEM_Float2())
                return result
                break
                            
            if(choice == '3'):
                result = Multiply(UserInputSEM_Float1(),UserInputSEM_Float2())
                return result
                break

            if(choice == '4'):
                result = UserInputSEM_Float1()
                return result
                break

    except TypeError:
        print("***Invalid entry. Please try again.*** error code 2.4\n")
        
        
############################################################################
## SEM_HexOperation                                                       ##
##                                                                        ##
## Author: Davis, Richard                                                 ##
##                                                                        ##
## Purpose:  to take and handle input in the form of IEEE-754 Hexadecimal ##
##                                                                        ##
## Usage: def: ValType2                                                   ##
##                                                                        ##
## Returns: IEEE Floating point value passed through operation choice     ##
##                                                                        ##
## Functions:                                                             ##
## Add                    | SARN_IEEE754_Converter_Calculator_v2.4.1.py   ##
## Subtract               | SARN_IEEE754_Converter_Calculator_v2.4.1.py   ##
## Multiply               | SARN_IEEE754_Converter_Calculator_v2.4.1.py   ##
## UserInputSEM_Bin_Fix1  | SARN_IEEE754_Converter_Calculator_v2.4.1.py   ##
##                                                                        ##
## Date: 6Dec22                                                           ##
############################################################################

#Define Hex operational choices
def SEM_HexOperation():
    
    choices = ['1','2','3','4']
    choice = input("\nSelect from the following choices:\n\n1 for Add\n2 for Subtract\n3 for Multiply\n4 to convert or show output\n\n Your Choice: ")
    print()
    try:
        while choice in choices:
                        
            if(choice == '1'):
                result = Add(UserInputSEM_Hex_Fix1(),UserInputSEM_Hex_Fix2())
                return result
                break
                            
            if(choice == '2'):
                result = Subtract(UserInputSEM_Hex_Fix1(),UserInputSEM_Hex_Fix2())
                return result
                break
                            
            if(choice == '3'):
                result = Multiply(UserInputSEM_Hex_Fix1(),UserInputSEM_Hex_Fix2())
                return result
                break

            if(choice == '4'):
                result = UserInputSEM_Hex_Fix1()
                return result
                break

    except TypeError:
        print("***Invalid entry. Please try again.*** error code 2.5\n")


############################################################################
## SEM_BinOperation                                                       ##
##                                                                        ##
## Author: Davis, Richard                                                 ##
##                                                                        ##
## Purpose:  to take and handle input in the form of IEEE-754 Binary data ##
##                                                                        ##
## Usage: def: ValType2                                                   ##
##                                                                        ##
## Returns: IEEE Floating point value passed through operation choice     ##
##                                                                        ##
## Functions:                                                             ##
## Add                    | SARN_IEEE754_Converter_Calculator_v2.4.1.py   ##
## Subtract               | SARN_IEEE754_Converter_Calculator_v2.4.1.py   ##
## Multiply               | SARN_IEEE754_Converter_Calculator_v2.4.1.py   ##
## UserInputSEM_Bin_Fix1  | SARN_IEEE754_Converter_Calculator_v2.4.1.py   ##
##                                                                        ##
## Date: 6Dec22                                                           ##
############################################################################

#Define Binary operational choices
def SEM_BinOperation():
    
    choices = ['1','2','3','4']
    choice = input("\nSelect from the following choices:\n\n1 for Add\n2 for Subtract\n3 for Multiply\n4 to convert or show output\n\n Your Choice: ")
    print()
    try:
        while choice in choices:
                        
            if(choice == '1'):
                result = Add(UserInputSEM_Bin_Fix1(),UserInputSEM_Bin_Fix2())
                return result
                break
                            
            if(choice == '2'):
                result = Subtract(UserInputSEM_Bin_Fixn1(),UserInputSEM_Bin_Fix2())
                return result
                break
                            
            if(choice == '3'):
                result = Multiply(UserInputSEM_Bin_Fix1(),UserInputSEM_Bin_Fix2())
                return result
                break

            if(choice == '4'):
                result = UserInputSEM_Bin_Fix1()
                return result
                break

    except TypeError:
        print("***Invalid entry. Please try again.*** error code 2.6\n")


############################################################################
## FloatToBinary                                                          ##
##                                                                        ##
## Author: Davis, Richard                                                 ##
##                                                                        ##
## Purpose: converts a IEEE-754 floating point number to IEEE-754 Binary  ##
##                                                                        ##
## Usage: def: ValType2                                                   ##
##                                                                        ##
## Returns: IEEE-754 Binary value                                         ##
##                                                                        ##
## Date: 2Nov22                                                           ##
############################################################################

#Converts SEM floating point to signed binary
def FloatToBinary(n):
    return ''.join('{:0>8b}'.format(c) for c in struct.pack('!f', n))
    
    
############################################################################
## HexToFloat                                                             ##
##                                                                        ##
## Author: Davis, Richard                                                 ##
##                                                                        ##
## Purpose: converts a IEEE-754 Hexadecimal to IEEE-754 Floating point    ##
##                                                                        ##
## Usage: def: ValType2                                                   ##
##                                                                        ##
## Returns: IEEE-754 Hexadecimal value                                    ##
##                                                                        ##
## Date: 6Dec22                                                           ##
############################################################################

#Convert Hex to SEM float
def HexToFloat(n):
    try:
        i = int(n, 16)
        cp = pointer(c_int(i))
        fp = cast(cp, POINTER(c_float))
        return fp.contents.value
        
    except ValueError:
        print("\nInvalid entry error code 2.8\n")


############################################################################
## BinaryToFloat                                                          ##
##                                                                        ##
## Author: Davis, Richard                                                 ##
##                                                                        ##
## Purpose: converts a IEEE-754 Binary to IEEE-754 Floating point         ##
##                                                                        ##
## Usage: def: ValType2                                                   ##
##                                                                        ##
## Returns: IEEE-754 Float value                                          ##
##                                                                        ##
## Date: 2Nov22                                                           ##
############################################################################

#Convert Binary to SEM Float
def BinaryToFloat(binary):

    try:
        return struct.unpack('!f',struct.pack('!I', int(binary, 2)))[0]

    except TypeError:
        print()
    except struct.error:
        print("\nArgument out of range error code 2.13\n")
        

###########################################################################
## SEM_FloatToHex                                                        ##
## FloatToBinary2                                                        ##
##                                                                       ##
## Author: Yash_R (partially modified by Richard D.)                     ##
##  https://www.geeksforgeeks.org/                                       ##
##                                                                       ##
## Purpose:  converts IEEE floating point to hexadecimal                 ##
##             this was a last minute add to fix a conversion issue      ##
##                                                                       ##
## Usage:  def: ValType2                                                 ##
##                                                                       ##
## Returns: Hexadecimal value                                            ##
##                                                                       ##
## Functions Called:                                                     ##
##  FloatToBinary2            | internal function of SEM_FloatToHex      ##
##                                                                       ##
## SEM_FloatToHex Date: 6Dec22                                           ##
###########################################################################

#SEM float to binary used in SEM_FloatToHex
def FloatToBinary2(number, DecPlace = 3):
	whole, dec = str(number).split(".")
	whole = int(whole)
	res = (str(bin(whole))+".").replace('0b','')

	for x in range(DecPlace):
		dec = str('0.')+str(dec)
		temp = '%1.20f' %(float(dec)*2)
		whole, dec = temp.split(".")
		res += whole
	return res

#SEM float to Hex (from binary)
def SEM_FloatToHex(n) :
	#positive or negative
	sign = 0
	if n < 0 :
		sign = 1
		n = n * (-1)
	dp = 30
	#convert float to binary
	dec = FloatToBinary2 (n, DecPlace = dp)

	dotPlace = dec.find('.')
	onePlace = dec.find('1')

	if onePlace > dotPlace:
		dec = dec.replace(".","")
		onePlace -= 1
		dotPlace -= 1
	elif onePlace < dotPlace:
		dec = dec.replace(".","")
		dotPlace -= 1
	mantissa = dec[onePlace+1:]

	exponent = dotPlace - onePlace
	exponent_bits = exponent + 127

	exponent_bits = bin(exponent_bits).replace("0b",'')

	mantissa = mantissa[0:23]

	#SEM float to rounded binary
	final = str(sign) + exponent_bits.zfill(8) + mantissa

	#SEM binary to rounded hexadecimal
	hstr = '%0*X' %((len(final) + 3) // 4, int(final, 2))
	return (hstr)


############################################################################
## ValType2                                                               ##
##                                                                        ##
## Author: Davis, Richard                                                 ##
##                                                                        ##
## Purpose: calls functions to accept input selections                    ##
##  and directs flow of program and calls                                 ##
##                                                                        ##
## Usage: def: Main()                                                     ##
##                                                                        ##
## Returns: returns functions called to Main                              ##
##                                                                        ##
## Functions:                                                             ##
## SEM_FloatOperation | SARN_IEEE754_Converter_Calculator_v2.4.1.py       ##
## SEM_HexOperation   | SARN_IEEE754_Converter_Calculator_v2.4.1.py       ##
## SEM_BinOperation   | SARN_IEEE754_Converter_Calculator_v2.4.1.py       ##
## FloatToBinary      | SARN_IEEE754_Converter_Calculator_v2.4.1.py       ##
## HexToFloat         | SARN_IEEE754_Converter_Calculator_v2.4.1.py       ##
## BinaryToFloat      | SARN_IEEE754_Converter_Calculator_v2.4.1.py       ##
## FloatToBinary2     | SARN_IEEE754_Converter_Calculator_v2.4.1.py       ##
## SEM_FloatToHex     | SARN_IEEE754_Converter_Calculator_v2.4.1.py       ##
##                                                                        ##
## Date: 6Dec22                                                           ##
############################################################################

#Define numeric value type choices
def ValType2():
    input_choices = ['1','2','3']
    input_choice = input("\nSelect the input value type:\n\n1 for IEEE-754 Floating-Point value   (for example 345.26)\n"
                    + "2 for IEEE-754 Binary                 (for example 01000111010...)\n3 for IEEE-754 Hexadecimal            (for example 3F9E147B)\n\n Your Choice: ")
    print()
    
    #while input_choice in input_choices:
    loop = True
    while loop:

        #Input SEM Float
        if(input_choice == '1'):
            try:
                output_choices = ['1','2','3']
                output_choice = input("\nSelect the output value type:\n\n1 for IEEE-754 Floating-Point value   (for example 345.26)\n"
                                + "2 for IEEE-754 Binary                 (for example 01000111010...)\n3 for IEEE-754 Hexadecimal            (for example 3F9E147B)\n\n Your Choice: ")
                print()
                
                #while choice in choices:
                loop2 = True
                while loop2:

                    #Output SEM Float
                    if(output_choice == '1'):
                        try:
                            x = SEM_FloatOperation()
                            if (x == 0.0):
                                print("\nZero special flag caught:\n\nYou entered: 0\n\n")
                                #return 0
                            if (x == "nan"):
                                print("\nNaN special flag caught:\n\nYou entered: 0\n\n")
                                #return 0                        
                            result = x
                            if result is None:
                                raise TypeError
                            else: print("The result is:\n\n", result, "\n")
                        except TypeError:
                            print("***Invalid entry. Please try again.*** error code 2.25\n")
                        break

                    #Output SEM Binary
                    elif(output_choice == '2'):
                        try:
                            x = SEM_FloatOperation()
                            if (x == 0.0):
                                print("\nZero special flag caught:\n\nYou entered: 0\n\n")
                                #return 0
                            if (x == "nan"):
                                print("\nNaN special flag caught:\n\nYou entered: 0\n\n")
                                #return 0                        
                            result = FloatToBinary(x)
                            if result is None:
                                raise TypeError
                            else: print("The result is:\n\n", result, "\n")
                        except TypeError:
                            print("***Invalid entry. Please try again.*** error code 2.26\n")
                        break

                    #Output SEM Hex
                    elif(output_choice == '3'):
                        try:
                            x = SEM_FloatOperation()
                            if (x == 0.0):
                                print("\nZero special flag caught:\n\nYou entered: 0\n\n")
                                #return 0
                            if (x == "nan"):
                                print("\nNaN special flag caught:\n\nYou entered: 0\n\n")
                                #return 0                        
                            result = SEM_FloatToHex(x)
                            if result is None:
                                raise TypeError
                            else: print("The result is:\n\n", result, "\n")
                        except TypeError:
                            print("***Invalid entry. Please try again.*** error code 2.27\n")
                        break

                    while output_choice not in output_choices:
                        loop2 = False
                        print("***Invalid entry. Please try again.*** error code 2.32\n")
                        break                    

            except TypeError:
                print("***Invalid entry. Please try again.*** error code 2.33\n")

            break

        #Input SEM Binary
        elif(input_choice == '2'):
            try:
                output_choices = ['1','2','3']
                output_choice = input("\nSelect the output value type:\n\n1 for IEEE-754 Floating-Point value   (for example 345.26)\n"
                                + "2 for IEEE-754 Binary                 (for example 01000111010...)\n3 for IEEE-754 Hexadecimal            (for example 3F9E147B)\n\n Your Choice: ")
                print()
                
                #while choice in choices:
                loop2 = True
                while loop2:

                    #Output SEM Float
                    if(output_choice == '1'):
                        try:
                            x = SEM_BinOperation()
                            if (x == 0.0):
                                print("\nZero special flag caught:\n\nYou entered: 0\n\n")
                                #return 0
                            if (x == "nan"):
                                print("\nNaN special flag caught:\n\nYou entered: 0\n\n")
                                #return 0                        
                            result = x                            
                            if result is None:
                                raise TypeError
                            else: print("The result is:\n\n", result, "\n")
                        except TypeError:
                            print("***Invalid entry. Please try again.*** error code 2.34\n")
                        break

                    #Output SEM Binary
                    elif(output_choice == '2'):
                        try:
                            x = SEM_BinOperation()
                            if (x == 0.0):
                                print("\nZero special flag caught:\n\nYou entered: 0\n\n")
                                #return 0
                            if (x == "nan"):
                                print("\nNaN special flag caught:\n\nYou entered: 0\n\n")
                                #return 0                                            
                            result = FloatToBinary(x)
                            if result is None:
                                raise TypeError
                            else: print("The result is:\n\n", result, "\n")
                        except TypeError:
                            print("***Invalid entry. Please try again.*** error code 2.35\n")
                        break

                    #Output SEM Hex
                    elif(output_choice == '3'):
                        try:
                            x = SEM_BinOperation()
                            if (x == 0.0):
                                print("\nZero special flag caught:\n\nYou entered: 0\n\n")
                                #return 0
                            if (x == "nan"):
                                print("\nNaN special flag caught:\n\nYou entered: 0\n\n")
                                #return 0                                            
                            result = SEM_FloatToHex(x)
                            if result is None:
                                raise TypeError
                            else: print("The result is:\n\n", result, "\n")
                        except TypeError:
                            print("***Invalid entry. Please try again.*** error code 2.36\n")
                        break

                    while output_choice not in output_choices:
                        loop2 = False
                        print("***Invalid entry. Please try again.*** error code 2.41\n")
                        break

            except TypeError:
                print("***Invalid entry. Please try again.*** error code 2.42\n")

            break

        #Input SEM Hex
        elif(input_choice == '3'):
            try:
                output_choices = ['1','2','3']
                output_choice = input("\nSelect the output value type:\n\n1 for IEEE-754 Floating-Point value   (for example 345.26)\n"
                                + "2 for IEEE-754 Binary                 (for example 01000111010...)\n3 for IEEE-754 Hexadecimal            (for example 3F9E147B)\n\n Your Choice: ")
                print()
                
                #while choice in choices:
                loop2 = True
                while loop2:

                    #Output SEM Float
                    if(output_choice == '1'):
                        try:
                            x = SEM_HexOperation()
                            if (x == 0.0):
                                print("\nZero special flag caught:\n\nYou entered: 0\n\n")
                                #return 0
                            if (x == "nan"):
                                print("\nNaN special flag caught:\n\nYou entered: 0\n\n")
                                #return 0                        
                            result = x
                            if result is None:
                                raise TypeError
                            else: print("The result is:\n\n", result, "\n")
                        except TypeError:
                            print("***Invalid entry. Please try again.*** error code 2.43\n")
                        break

                    #Output SEM Binary
                    elif(output_choice == '2'):
                        try:
                            x = SEM_HexOperation()
                            if (x == 0.0):
                                print("\nZero special flag caught:\n\nYou entered: 0\n\n")
                                #return 0
                            if (x == "nan"):
                                print("\nNaN special flag caught:\n\nYou entered: 0\n\n")
                                #return 0
                            result = FloatToBinary(x)
                            if result is None:
                                raise TypeError
                            else: print("The result is:\n\n", result, "\n")
                        except TypeError:
                            print("***Invalid entry. Please try again.*** error code 2.44\n")
                        break

                    #Output SEM Hex
                    elif(output_choice == '3'):
                        try:
                            x = SEM_HexOperation()
                            if (x == 0.0):
                                print("\nZero special flag caught:\n\nYou entered: 0\n\n")
                                #return 0
                            if (x == "nan"):
                                print("\nNaN special flag caught:\n\nYou entered: 0\n\n")
                                #return 0
                            result = SEM_FloatToHex(x)
                            if result is None:
                                raise TypeError
                            else: print("The result is:\n\n", result, "\n")
                        except TypeError:
                            print("***Invalid entry. Please try again.*** error code 2.45\n")
                        break

                    while output_choice not in output_choices:
                        loop2 = False
                        print("***Invalid entry. Please try again.*** error code 2.50\n")
                        break

            except TypeError:
                print("***Invalid entry. Please try again.*** error code 2.51\n")

            break
            
        while input_choice not in input_choices:
            loop = False
            print("***Invalid entry. Please try again.*** error code 2.61\n")
            break   


############################################################################
## UserInputSEM_Float_Fix1                                                ##
## UserInputSEM_Float_Fix2                                                ##
##                                                                        ##
## Author: Davis, Richard                                                 ##
##                                                                        ##
## Purpose:  Asks and takes user input 1 & 2 for IEEE-754 Floating value  ##
##                                                                        ##
## Usage: def: SEM_FloatOperation                                         ##
##                                                                        ##
## Returns: IEEE-754 Floating value                                       ##           
##                                                                        ##
## Date: 6Dec22                                                           ##
############################################################################

#Define user input IEEE-754 Float- To use: UserInputSEM_Float1(),UserInputSEM_Float2()
def UserInputSEM_Float1():
    loop = True
    while loop:
        try:
            x = input("Enter first IEEE-754 floating point value: ")
            return float(x)
            loop = False
            break

        except ValueError:
            try:
                print("\nYou entered:",n,"\nThis is either an invalid entry or not a number, please try again.\n")
                x = UserInputSEM_Float1()
                return x
            except NameError:
                print("\nYou entered:",n,"\nThis is either an invalid entry or not a number, please try again.\n")
                x = UserInputSEM_Float1()
                return x 
        except TypeError:
            print("\nInvalid entry type, please try again.\n")
            x = UserInputSEM_Float1()
            return x  

def UserInputSEM_Float2():
    loop = True
    while loop:
        try:
            x = input("Enter second IEEE-754 floating point value: ")
            return float(x)
            loop = False
            break

        except ValueError:
            try:
                print("\nYou entered:",n,"\nThis is either an invalid entry or not a number, please try again.\n")
                x = UserInputSEM_Float2()
                return x
            except NameError:
                print("\nYou entered:",n,"\nThis is either an invalid entry or not a number, please try again.\n")
                x = UserInputSEM_Float2()
                return x 
        except TypeError:
            print("\nInvalid entry type, please try again.\n")
            x = UserInputSEM_Float2()
            return x            
            
            
############################################################################
## hex_SEM_fix1                                                           ##
## hex_SEM_fix2                                                           ##
## UserInputSEM_Hex_Fix1                                                  ##
## UserInputSEM_Hex_Fix2                                                  ##
##                                                                        ##
## Author: Davis, Richard                                                 ##
##                                                                        ##
## Purpose:  Asks and takes user input 1 & 2 for IEEE-754 Hexadecimal     ##
##              the SEM_fix(s) do the convertion and handle errors        ##
##              while the UserInputSEM loop/repeat input if error caught  ##
##                                                                        ##
## Usage: def: SEM_HexOperation                                           ##
##                                                                        ##
## Returns: IEEE-754 Floating value                                       ## 
##                                                                        ##
## Functions:                                                             ##
## hex_SEM_fix1 | SARN_IEEE754_Converter_Calculator_v2.4.1.py             ##
## hex_SEM_fix2 | SARN_IEEE754_Converter_Calculator_v2.4.1.py             ##
##                                                                        ##
## Date: 6Dec22                                                           ##
############################################################################

#UserInputSEM_Hex_Fix1
def hex_SEM_fix1(n):
    try:
        i = int(n, 16)
        cp = pointer(c_int(i))
        fp = cast(cp, POINTER(c_float))
        return Decimal(fp.contents.value)
                            
    except ValueError:
        print("\nYou entered:",n,"\nThis is either an invalid entry or not a number, please try again.\n")
        x = UserInputSEM_Hex_Fix1()
        return x
    except TypeError:
        print("\nInvalid entry type, please try again.\n")
        x = UserInputSEM_Hex_Fix1()
        return x
        
#UserInputSEM_Hex_Fix2
def hex_SEM_fix2(n):
    try:
        i = int(n, 16)
        cp = pointer(c_int(i))
        fp = cast(cp, POINTER(c_float))
        return Decimal(fp.contents.value)
                            
    except ValueError:
        print("\nYou entered:",n,"\nThis is either an invalid entry or not a number, please try again.\n")
        x = UserInputSEM_Hex_Fix2()
        return x
    except TypeError:
        print("\nInvalid entry type, please try again.\n")
        x = UserInputSEM_Hex_Fix2()
        return x

#Define user input Hex-Fix for SignExpMan To use: UserInputSEM_Hex_Fix1(),UserInputSEM_Hex_Fix2()
def UserInputSEM_Hex_Fix1():
    loop = True
    while loop:
        try:
            x = input("Enter first IEEE-754 hexadecimal value: ")
            return hex_SEM_fix1(x)
            loop = False
            break

        except ValueError:
            print("\nInvalid entry error code 2.66\n")
            
#SEM Hex fix 2
def UserInputSEM_Hex_Fix2():
    loop = True
    while loop:
        try:
            x = input("Enter second IEEE-754 hexadecimal value: ")
            return hex_SEM_fix2(x)
            loop = False
            break

        except ValueError:
            print("\nInvalid entry error code 2.67\n")


############################################################################
## bin_SEM_fix1                                                           ##
## bin_SEM_fix2                                                           ##
## UserInputSEM_Bin_Fix1                                                  ##
## UserInputSEM_Bin_Fix2                                                  ##
##                                                                        ##
## Author: Davis, Richard                                                 ##
##                                                                        ##
## Purpose:  Asks and takes user input 1 & 2 for IEEE-754 Binary          ##
##              the SEM_fix(s) do the convertion and handle errors        ##
##              while the UserInputSEM loop/repeat input if error caught  ##
##                                                                        ##
## Usage: def: SEM_BinOperation                                           ##
##                                                                        ##
## Returns: IEEE-754 Floating value                                       ## 
##                                                                        ##
## Functions:                                                             ##
## hex_SEM_fix1 | SARN_IEEE754_Converter_Calculator_v2.4.1.py             ##
## hex_SEM_fix2 | SARN_IEEE754_Converter_Calculator_v2.4.1.py             ##
##                                                                        ##
## Date: 6Dec22                                                           ##
############################################################################

#UserInputSEM_Bin_Fix1
def bin_SEM_fix1(n):
    val1 = n
    try:
    
        floating = struct.unpack('!f',struct.pack('!I', int(val1, 2)))[0]
        return floating
                        
    except ValueError:
        print("\nYou entered:",n,"\nThis is either an invalid entry or not a number, please try again.\n")
        x = UserInputSEM_Bin_Fix1()
        return x
    except TypeError:
        print("\nInvalid entry type, please try again.\n")
        x = UserInputSEM_Bin_Fix1()
        return x        

#UserInputSEM_Bin_Fix2
def bin_SEM_fix2(n):
    val1 = n
    try:
        floating = struct.unpack('!f',struct.pack('!I', int(val1, 2)))[0]
        return floating
                        
    except ValueError:
        print("\nYou entered:",n,"\nThis is either an invalid entry or not a number, please try again.\n")
        x = UserInputSEM_Bin_Fix2()
        return x
    except TypeError:
        print("\nInvalid entry type, please try again.\n")
        x = UserInputSEM_Bin_Fix2()
        return x   
            

#Define user input Binary- To use: UserInputSEM_Bin_Fix1(),UserInputSEM_Bin_Fix2()
def UserInputSEM_Bin_Fix1():
        
    loop = True
    while loop:
        try:
            x = input("Enter first IEEE-754 binary value: ")
            return bin_SEM_fix1(x)
            loop = False
            break

        except ValueError:
            print("\nInvalid entry error code 2.70\n")


def UserInputSEM_Bin_Fix2():
    loop = True
    while loop:
        try:
            x = input("Enter second IEEE-754 binary value: ")
            return bin_SEM_fix2(x)
            loop = False
            break

        except ValueError:
            print("\nInvalid entry error code 2.71\n")


############################################################################
## Main                                                                   ##
##                                                                        ##
## Author: Davis, Richard                                                 ##
##                                                                        ##
## Purpose: Calls ValType2 and repaets entire code or                     ##
##              exists program after 2 seconds pass                       ##
##                                                                        ##
## Usage: N/A                                                             ##
##                                                                        ##
## Returns: No return type                                                ##
##                                                                        ##
## Functions:                                                             ##
## ValType2 | SARN_IEEE754_Converter_Calculator_v2.4.1.py                 ##
##                                                                        ##
## Date: 6Dec22                                                           ##
############################################################################

#Main Program:
def Main():
    #User input for answer
    answer = ['yes','YES','Yes','y','Y']
    repeat = 'yes'
        
    #Loop for answer
    while repeat in answer:
        ValType2()
        
        repeat = input("Would you like to continue?\n\n")
            
    else: 
        print("\nThe program will now exit.")
        time.sleep(2)

#Calling Main()
Main()
